<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>SyncRequestProcessor.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server</a> &gt; <span class="el_source">SyncRequestProcessor.java</span></div><h1>SyncRequestProcessor.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.server;

import java.io.Flushable;
import java.io.IOException;
import java.util.LinkedList;
import java.util.Random;
import java.util.concurrent.LinkedBlockingQueue;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * This RequestProcessor logs requests to disk. It batches the requests to do
 * the io efficiently. The request is not passed to the next RequestProcessor
 * until its log has been synced to disk.
 *
 * SyncRequestProcessor is used in 3 different cases
 * 1. Leader - Sync request to disk and forward it to AckRequestProcessor which
 *             send ack back to itself.
 * 2. Follower - Sync request to disk and forward request to
 *             SendAckRequestProcessor which send the packets to leader.
 *             SendAckRequestProcessor is flushable which allow us to force
 *             push packets to leader.
 * 3. Observer - Sync committed request to disk (received as INFORM packet).
 *             It never send ack back to the leader, so the nextProcessor will
 *             be null. This change the semantic of txnlog on the observer
 *             since it only contains committed txns.
 */
public class SyncRequestProcessor extends ZooKeeperCriticalThread implements RequestProcessor {
<span class="fc" id="L48">    private static final Logger LOG = LoggerFactory.getLogger(SyncRequestProcessor.class);</span>
    private final ZooKeeperServer zks;
<span class="fc" id="L50">    private final LinkedBlockingQueue&lt;Request&gt; queuedRequests =</span>
        new LinkedBlockingQueue&lt;Request&gt;();
    private final RequestProcessor nextProcessor;

<span class="fc" id="L54">    private Thread snapInProcess = null;</span>
    volatile private boolean running;

    /**
     * Transactions that have been written and are waiting to be flushed to
     * disk. Basically this is the list of SyncItems whose callbacks will be
     * invoked after flush returns successfully.
     */
<span class="fc" id="L62">    private final LinkedList&lt;Request&gt; toFlush = new LinkedList&lt;Request&gt;();</span>
<span class="fc" id="L63">    private final Random r = new Random(System.nanoTime());</span>
    /**
     * The number of log entries to log before starting a snapshot
     */
<span class="fc" id="L67">    private static int snapCount = ZooKeeperServer.getSnapCount();</span>
    
    /**
     * The number of log entries before rolling the log, number
     * is chosen randomly
     */
    private static int randRoll;

<span class="fc" id="L75">    private final Request requestOfDeath = Request.requestOfDeath;</span>

    public SyncRequestProcessor(ZooKeeperServer zks,
            RequestProcessor nextProcessor) {
<span class="fc" id="L79">        super(&quot;SyncThread:&quot; + zks.getServerId(), zks</span>
<span class="fc" id="L80">                .getZooKeeperServerListener());</span>
<span class="fc" id="L81">        this.zks = zks;</span>
<span class="fc" id="L82">        this.nextProcessor = nextProcessor;</span>
<span class="fc" id="L83">        running = true;</span>
<span class="fc" id="L84">    }</span>
    
    /**
     * used by tests to check for changing
     * snapcounts
     * @param count
     */
    public static void setSnapCount(int count) {
<span class="fc" id="L92">        snapCount = count;</span>
<span class="fc" id="L93">        randRoll = count;</span>
<span class="fc" id="L94">    }</span>

    /**
     * used by tests to get the snapcount
     * @return the snapcount
     */
    public static int getSnapCount() {
<span class="fc" id="L101">        return snapCount;</span>
    }
    
    /**
     * Sets the value of randRoll. This method 
     * is here to avoid a findbugs warning for
     * setting a static variable in an instance
     * method. 
     * 
     * @param roll
     */
    private static void setRandRoll(int roll) {
<span class="fc" id="L113">        randRoll = roll;</span>
<span class="fc" id="L114">    }</span>

    @Override
    public void run() {
        try {
<span class="fc" id="L119">            int logCount = 0;</span>

            // we do this in an attempt to ensure that not all of the servers
            // in the ensemble take a snapshot at the same time
<span class="fc" id="L123">            setRandRoll(r.nextInt(snapCount/2));</span>
            while (true) {
<span class="fc" id="L125">                Request si = null;</span>
<span class="fc bfc" id="L126" title="All 2 branches covered.">                if (toFlush.isEmpty()) {</span>
<span class="fc" id="L127">                    si = queuedRequests.take();</span>
                } else {
<span class="fc" id="L129">                    si = queuedRequests.poll();</span>
<span class="fc bfc" id="L130" title="All 2 branches covered.">                    if (si == null) {</span>
<span class="fc" id="L131">                        flush(toFlush);</span>
<span class="fc" id="L132">                        continue;</span>
                    }
                }
<span class="fc bfc" id="L135" title="All 2 branches covered.">                if (si == requestOfDeath) {</span>
<span class="fc" id="L136">                    break;</span>
                }
<span class="pc bpc" id="L138" title="1 of 2 branches missed.">                if (si != null) {</span>
                    // track the number of records written to the log
<span class="fc bfc" id="L140" title="All 2 branches covered.">                    if (zks.getZKDatabase().append(si)) {</span>
<span class="fc" id="L141">                        logCount++;</span>
<span class="fc bfc" id="L142" title="All 2 branches covered.">                        if (logCount &gt; (snapCount / 2 + randRoll)) {</span>
<span class="fc" id="L143">                            randRoll = r.nextInt(snapCount/2);</span>
                            // roll the log
<span class="fc" id="L145">                            zks.getZKDatabase().rollLog();</span>
                            // take a snapshot
<span class="fc bfc" id="L147" title="All 4 branches covered.">                            if (snapInProcess != null &amp;&amp; snapInProcess.isAlive()) {</span>
<span class="fc" id="L148">                                LOG.warn(&quot;Too busy to snap, skipping&quot;);</span>
                            } else {
<span class="fc" id="L150">                                snapInProcess = new ZooKeeperThread(&quot;Snapshot Thread&quot;) {</span>
                                        public void run() {
                                            try {
<span class="fc" id="L153">                                                zks.takeSnapshot();</span>
<span class="nc" id="L154">                                            } catch(Exception e) {</span>
<span class="nc" id="L155">                                                LOG.warn(&quot;Unexpected exception&quot;, e);</span>
<span class="fc" id="L156">                                            }</span>
<span class="fc" id="L157">                                        }</span>
                                    };
<span class="fc" id="L159">                                snapInProcess.start();</span>
                            }
<span class="fc" id="L161">                            logCount = 0;</span>
                        }
<span class="fc bfc" id="L163" title="All 2 branches covered.">                    } else if (toFlush.isEmpty()) {</span>
                        // optimization for read heavy workloads
                        // iff this is a read, and there are no pending
                        // flushes (writes), then just pass this to the next
                        // processor
<span class="pc bpc" id="L168" title="1 of 2 branches missed.">                        if (nextProcessor != null) {</span>
<span class="fc" id="L169">                            nextProcessor.processRequest(si);</span>
<span class="pc bpc" id="L170" title="1 of 2 branches missed.">                            if (nextProcessor instanceof Flushable) {</span>
<span class="nc" id="L171">                                ((Flushable)nextProcessor).flush();</span>
                            }
                        }
                        continue;
                    }
<span class="fc" id="L176">                    toFlush.add(si);</span>
<span class="fc bfc" id="L177" title="All 2 branches covered.">                    if (toFlush.size() &gt; 1000) {</span>
<span class="fc" id="L178">                        flush(toFlush);</span>
                    }
                }
<span class="fc" id="L181">            }</span>
<span class="nc" id="L182">        } catch (Throwable t) {</span>
<span class="nc" id="L183">            handleException(this.getName(), t);</span>
<span class="nc" id="L184">            running = false;</span>
<span class="nc" id="L185">            System.exit(11);</span>
<span class="fc" id="L186">        }</span>
<span class="fc" id="L187">        LOG.info(&quot;SyncRequestProcessor exited!&quot;);</span>
<span class="fc" id="L188">    }</span>

    private void flush(LinkedList&lt;Request&gt; toFlush)
        throws IOException, RequestProcessorException
    {
<span class="pc bpc" id="L193" title="1 of 2 branches missed.">        if (toFlush.isEmpty())</span>
<span class="nc" id="L194">            return;</span>

<span class="fc" id="L196">        zks.getZKDatabase().commit();</span>
<span class="fc bfc" id="L197" title="All 2 branches covered.">        while (!toFlush.isEmpty()) {</span>
<span class="fc" id="L198">            Request i = toFlush.remove();</span>
<span class="fc bfc" id="L199" title="All 2 branches covered.">            if (nextProcessor != null) {</span>
<span class="fc" id="L200">                nextProcessor.processRequest(i);</span>
            }
<span class="fc" id="L202">        }</span>
<span class="fc bfc" id="L203" title="All 4 branches covered.">        if (nextProcessor != null &amp;&amp; nextProcessor instanceof Flushable) {</span>
<span class="fc" id="L204">            ((Flushable)nextProcessor).flush();</span>
        }
<span class="fc" id="L206">    }</span>

    public void shutdown() {
<span class="fc" id="L209">        LOG.info(&quot;Shutting down&quot;);</span>
<span class="fc" id="L210">        queuedRequests.add(requestOfDeath);</span>
        try {
<span class="pc bpc" id="L212" title="1 of 2 branches missed.">            if(running){</span>
<span class="fc" id="L213">                this.join();</span>
            }
<span class="fc bfc" id="L215" title="All 2 branches covered.">            if (!toFlush.isEmpty()) {</span>
<span class="fc" id="L216">                flush(toFlush);</span>
            }
<span class="fc" id="L218">        } catch(InterruptedException e) {</span>
<span class="fc" id="L219">            LOG.warn(&quot;Interrupted while wating for &quot; + this + &quot; to finish&quot;);</span>
<span class="nc" id="L220">        } catch (IOException e) {</span>
<span class="nc" id="L221">            LOG.warn(&quot;Got IO exception during shutdown&quot;);</span>
<span class="nc" id="L222">        } catch (RequestProcessorException e) {</span>
<span class="nc" id="L223">            LOG.warn(&quot;Got request processor exception during shutdown&quot;);</span>
<span class="pc" id="L224">        }</span>
<span class="fc bfc" id="L225" title="All 2 branches covered.">        if (nextProcessor != null) {</span>
<span class="fc" id="L226">            nextProcessor.shutdown();</span>
        }
<span class="fc" id="L228">    }</span>

    public void processRequest(Request request) {
        // request.addRQRec(&quot;&gt;sync&quot;);
<span class="fc" id="L232">        queuedRequests.add(request);</span>
<span class="fc" id="L233">    }</span>

}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>